# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Read command line arguments
# Set defaults; SMF_FMRI should have been set, but just in case.
if [ -z "$SMF_FMRI" ]; then
fi
'start')
rndc_cmd_opts="-a"
cmdopts=""
properties="debug_level ip_interfaces listen_on_port
threads chroot_dir configuration_file server"
do
if [ -z "${value}" -o "${value}" = '""' ]; then
continue;
fi
'debug_level')
cmdopts="${cmdopts} -d ${value}"
fi
;;
'ip_interfaces')
'IPv4')
cmdopts="${cmdopts} -4";;
'IPv6')
cmdopts="${cmdopts} -6";;
'all')
: # Default is all, therefore ignore.
;;
*)
echo "$I: Unrecognised value in service instance property" >&2
echo "$I: options/${prop} : ${value}" >&2
;;
esac
;;
'listen_on_port')
cmdopts="${cmdopts} -p ${value}"
fi
;;
'threads')
cmdopts="${cmdopts} -n ${value}"
fi
;;
'chroot_dir')
cmdopts="${cmdopts} -t ${value}"
chroot_dir=${value};
;;
'configuration_file')
cmdopts="${cmdopts} -c ${value}"
;;
'server')
server=$@
;;
esac
done
# If chroot option is set, note zones(5) are preferred, then
# configuration file lives under chroot directory.
if [ "${chroot_dir}" != "" ]; then
rndc_cmd_opts="${rndc_cmd_opts} -t ${chroot_dir}"
fi
# Check if the rndc config file exists.
if [ ! -f ${rndc_config_file} ]; then
# If not, check if the default rndc key file exists.
if [ ! -f ${rndc_key_file} ]; then
echo "$I: Creating default rndc key file: ${rndc_key_file}." >&2
if [ $? -ne 0 ]; then
echo "$I : Warning: rndc configuration failed! Use of 'rndc' to" \
"control 'named' may fail and 'named' may report further error" \
"messages to the system log. This is not fatal. For more" \
"information see rndc(1M) and rndc-confgen(1M)." >&2
fi
fi
fi
# Check configuration file exists.
if [ ! -f ${configuration_file} ]; then
msg="$I : Configuration file ${configuration_file} does not exist!"
echo ${msg} >&2
# dns-server should be placed in maintenance state.
fi
if [ ${result} = ${SMF_EXIT_OK} ]; then
echo "$I: Executing: ${server} ${cmdopts}"
# Execute named(1M) with relevant command line options. Note
# the server forks before reading named.conf(4) and so a
# good exit code here does not mean the service is ready.
result=$?
echo "$I : start failed! Check syslog for further information." >&2
fi
fi
;;
'stop')
;;
*)
echo "Usage: $I [stop|start] <instance>" >&2
exit 1
;;
esac
exit ${result}